class.CutTape() -- "Generators" but make sounds instead of images

function CutTape:_init(spec)
	pull(self,spec)
end

function CutTape:build()
	local result = project.playset_make()
	self.play = self.play or SampleCache(self.path)
	self:cuts()
	
	local sampleset = project.make_sampleset(self.seg, self.seglen)
	project.playset_set(result, sampleset, 1, 0,0,0,0,0)
	return result
end

function CutTape:cuts()
	local seg = {}
	
	local start = 0
	local size = 0
	
	for i=0,(self.play.len-1) do
		local sample = self.play.data[i]
		size = size + 1
		if size >= self.span then
			local cropped = project.crop(self.play, start, size)
			table.insert(seg, cropped)
			start = i+1
			size = 0
		end
	end
	
	local memo = {}
	
	local function sortValue(a)
		local total = memo[a]
		total = 0
		for i=0,(a.len-1) do
			local sample = a.data[i]
			total = total + sample * sample
		end
		memo[a] = total
		return total
	end
	local function sortTest(a, b) return sortValue(a) < sortValue(b) end
	
	table.sort(seg, sortTest)
	
	self.seg = engine.ffi.new(string.format("struct sample*[%d]", #seg), seg)
	self.seglen = #seg
end

CutTape({path="resource/audio/devon-bg1.ogg", span=1024*4})