-- Additional Things. On-screne actors

-- SOUNDS
local square = project.square_make()
project.square_set(square,0,0,0)
project.sound_start(square)

local sampleplayer = project.playsample_make()
project.playsample_mute(sampleplayer)
project.sound_start(sampleplayer)

function oggname(x) return string.format("resource/audio/%s.ogg", x) end
function oggnamed(x) return SampleCache(oggname(x)) end

-- Util functions

function skewx(surface, fx, fy, fw, fh, by) -- Negative numbers act funny, idk why
	for y=0,(fh-1) do
		local line = {}
		for x=0,(fw-1) do table.insert(line, project.get_color(surface, fx+x, fy+y)) end
		for x,v in ipairs(line) do
			local off = (x-1+by)%fw
			if off<0 then off = off + fw end
			project.set_color(surface, off, fy+y, v)
		end
	end
end
function skewy(surface, fx, fy, fw, fh, by)
	for x=0,(fw-1) do
		local line = {}
		for y=0,(fh-1) do table.insert(line, project.get_color(surface, fx+x, fy+y)) end
		for y,v in ipairs(line) do
			local off = (y-1+by)%fh
			if off<0 then off = off + fh end
			project.set_color(surface, fx+x, off, v)
		end
	end
end
function skewx_channel(surface, fx, fy, fw, fh, by, channel) -- Negative numbers act funny, idk why
	for y=0,(fh-1) do
		local line = {}
		for x=0,(fw-1) do table.insert(line, project.get_color_x(surface, channel, fx+x, fy+y)) end
		for x,color in ipairs(line) do
			local off = (x-1+by)%fw
--			if off<0 then off = off + fw end -- Only called positive atm
			project.set_color_x(surface, channel, off, fy+y, color)
		end
	end
end


-- Actual things

class.Player(Thing)

function Player:_init(spec)
	pull(self, {
		down = {
			-- NUMBER ROW
			-- `
			-- NUMBERS taken, see pres			
			-- DASH. Equals is TAKEN! see snapshot
			
			-- TOP ROW
			[engine.sdl.SDL_SCANCODE_Q]=function(self) 
				if self.y>2 then --and self.stage:passable(self.x, self.y-1) then
					self.y = self.y - 1
				project.circle_thing(self.stage.base, self.x, self.y)
				end
			end,
			[engine.sdl.SDL_SCANCODE_W]=function(self)
				project.bandit(self.stage.base)
			end,
			[engine.sdl.SDL_SCANCODE_E]=function(self)
				project.find_edges(self.stage.base, 2, 192, engine.color_make(255,0,0,255))
			end,
			[engine.sdl.SDL_SCANCODE_R]=function(self)
				local w,h = self.stage.base.w,self.stage.base.h
				for y=1,h do
					skewx(self.stage.base, 0,y-1,self.stage.base.w, 1,y)
				end
			end,
			[engine.sdl.SDL_SCANCODE_T]=function(self)
				project.do_another_thing(self.stage.base)
			end,
			[engine.sdl.SDL_SCANCODE_Y]=function(self)
				project.do_a_thing(self.stage.base)
			end,
			[engine.sdl.SDL_SCANCODE_U]=function(self) -- Unfortunately mostly a cut and paste of "B"
				local base = self.stage.base
				local w,h = base.w,base.h
				local max = w*h
				local function idx(_i)
					local i = _i-1
					return i%w,math.floor(i/w)
				end
				local function unidx(_i)
					local i = max-_i
					return i%w,math.floor(i/w)
				end
				local function swap(a,b) return a,b end -- don't swap
				local function unswap(a,b) return b,a end -- swap
				local function pass(idxf, swapf)
					local x2,y2 = idxf(1) -- funny naming is so this can double as a "last"
					local c2 = project.get_color(base, x2,y2)
					for i=1,max-1 do
						local x1,y1 = x2,y2
						      x2,y2 = idxf(i+1)
						local c1 = c2
						      c2 = project.get_color(base, x2,y2)
						local lesser, greater = swapf(project.lesser(c1,c2), project.greater(c1,c2))
						project.set_color(base, x1,y1, lesser)
						project.set_color(base, x2,y2, greater)
						c2 = greater
					end
				end
				for i=1,4 do
					pass(idx, swap)
					pass(unidx, unswap)
				end
			end,
			[engine.sdl.SDL_SCANCODE_I]=function(self)
				project.do_a_weird_thing(self.stage.base)
			end,
			[engine.sdl.SDL_SCANCODE_O]=function(self)
				project.find_edges(self.stage.base, 0, 128, engine.color_gray(engine.white))
			end,
			[engine.sdl.SDL_SCANCODE_P]=function(self) -- B for Bubble. Hee hee
				local base = self.stage.base
				local w,h = base.w,base.h
				local max = w*h
				local besides = engine.ticks%2
				local function idxf(_i)
					local i = _i-1+besides
					return i%w,math.floor(i/w)
				end
				for i=1,max-2,2 do
					local x1,y1 = idxf(i)
					local x2,y2 = idxf(i+1)
					local c1 = project.get_color(base, x1,y1)
					local c2 = project.get_color(base, x2,y2)
					project.set_color(base, x1,y1, c2)
					project.set_color(base, x2,y2, c1)
				end
			end, 
			-- [, ], |
			
			-- MIDDLE ROW
			[engine.sdl.SDL_SCANCODE_A]=function(self)
				project.find_edges(self.stage.base, 1, 128, engine.color_make(0,255,0,255))
			end,
			-- S is TAKEN! See down
			[engine.sdl.SDL_SCANCODE_D]=function(self)
				skewx_channel(self.stage.base, 0,0,self.stage.base.w, self.stage.base.h,1, 0) -- Last arg is channel
				skewx_channel(self.stage.base, 0,0,self.stage.base.w, self.stage.base.h,2, 1)
				skewx_channel(self.stage.base, 0,0,self.stage.base.w, self.stage.base.h,3, 2)
			end,
			[engine.sdl.SDL_SCANCODE_F]=function(self)
				project.down_thing(self.stage.base)
			end,
			[engine.sdl.SDL_SCANCODE_G]=function(self)
				project.do_a_locational_thing(self.stage.base, self.x, self.y)
			end,
			-- J
			[engine.sdl.SDL_SCANCODE_K]=function(self)
				local w,h = self.stage.base.w,self.stage.base.h
				if engine.ticks%4==0 then skewx(self.stage.base, 0,0,self.stage.base.w, self.stage.base.h/2,-1) end
				if engine.ticks%4==1 then skewy(self.stage.base, self.stage.base.w/2,0,self.stage.base.w/2, self.stage.base.h,-1) end
				if engine.ticks%4==2 then skewx(self.stage.base, 0,self.stage.base.h/2,self.stage.base.w, self.stage.base.h/2,1) end
				if engine.ticks%4==3 then skewy(self.stage.base, 0,0,self.stage.base.w/2, self.stage.base.h,1) end
			end,
			[engine.sdl.SDL_SCANCODE_L]=function(self)
				project.magic(self.stage.base)
			end,
			-- semicolon, quote
			
			-- BOTTOM ROW
			[engine.sdl.SDL_SCANCODE_Z]=function(self) 
				if self.x>2 then --and self.stage:passable(self.x-1, self.y) then
					self.x = self.x - 1
				project.circle_thing(self.stage.base, self.x, self.y)
				end
			end,
			-- X is TAKEN! See down
			[engine.sdl.SDL_SCANCODE_C]=function(self)
				if self.x<128 then --and self.stage:passable(self.x+1, self.y) then
					self.x = self.x + 1
				project.circle_thing(self.stage.base, self.x, self.y)
				end
			end,
			-- V
			[engine.sdl.SDL_SCANCODE_B]=function(self) -- B for Bubble. Hee hee
				local base = self.stage.base
				local w,h = base.w,base.h
				local max = w*h
				local function idx(_i)
					local i = _i-1
					return math.floor(i/w),i%w
				end
				local function unidx(_i)
					local i = max-_i
					return math.floor(i/w),i%w
				end
				local function cmp(a,b) return a < b end
				local function uncmp(a,b) return a > b end
				local function pass(idxf, cmpf)
					local x2,y2 = idxf(1) -- funny naming is so this can double as a "last"
					local c2 = project.get_color(base, x2,y2)
					for i=1,max-1 do
						local x1,y1 = x2,y2
						      x2,y2 = idxf(i+1)
						local c1 = c2
						      c2 = project.get_color(base, x2,y2)
						if cmpf(c1,c2) then
							project.set_color(base, x1,y1, c2)
							project.set_color(base, x2,y2, c1)
							c2 = c1
						end
					end
				end
				for i=1,4 do
					pass(idx, cmp)
					pass(unidx, uncmp)
				end
			end,
			[engine.sdl.SDL_SCANCODE_N]=function(self)
				if self.y<128 then --and self.stage:passable(self.x, self.y+1) then
					self.y = self.y + 1
				project.circle_thing(self.stage.base, self.x, self.y)
				end
			end,
			[engine.sdl.SDL_SCANCODE_M]=function(self)
				project.also_do_something_neat_idk(self.stage.base, engine.color_gray(engine.white))
			end,
			[engine.sdl.SDL_SCANCODE_SPACE]=function(self)
				--project.increase_similarity(self.stage.base, global_run.coolpic, self.x, self.y)
--				project.playsample_set(sampleplayer, oggnamed("sfx_0"), 1, 0)
				project.circle_thing(self.stage.base, self.x, self.y)
			end,
		},
		pressed = {
			[engine.sdl.SDL_SCANCODE_X]=function(self)
				self.blip = not self.blip
				project.playsample_set(sampleplayer, oggnamed("sfx_5"), 1, 0)
			end,
			[engine.sdl.SDL_SCANCODE_S]=function(self)
				temp = self.y
				self.y = self.x
				self.x = temp
				project.playsample_set(sampleplayer, oggnamed("sfx_4"), 1, 0)
			end,
			[engine.sdl.SDL_SCANCODE_H]=function(self)
				local base = self.stage.base
				local dupe = MapMake(base.w,base.h)
				MapCopy(dupe,base)
				local function inmap(size,x,y)
					x = engine.clamp(1,x*3,size) -- Should be -1 but want smear
					y = engine.clamp(1,y*3,size)
					return x,y
				end
				InPlacePyramid(base, dupe, inmap)
				MapKill(dupe)
				project.playsample_set(sampleplayer, oggnamed("sfx_3"), 1, 0)
			end,
			[engine.sdl.SDL_SCANCODE_UP]=function(self)
				local base = self.stage.base
				local dupe = MapMake(base.w,base.h)
				MapCopy(dupe,base)
				local function inmap(size,x,y)
					x = engine.clamp(1,size/3+x,size)
					y = engine.clamp(1,size/3+y,size)
					return x,y
				end
				InPlacePyramid(base, dupe, inmap)
				MapKill(dupe)
				project.playsample_set(sampleplayer, oggnamed("sfx_2"), 1, 0)
			end,
			[engine.sdl.SDL_SCANCODE_DOWN]=function(self)
				local base = self.stage.base
				local w,h = base.w, base.h
				local dupe = MapMake(w,h)
				MapCopy(dupe,base)
				local function filter(i,s)
					return math.floor(i/3)+(i%3)*math.floor(s/3)
				end
				for x=0,(w-1) do
					for y=0,(h-1) do
						local c = project.get_color(dupe, x,y)
						project.set_color(base, filter(x,w),filter(y,h), c)
					end
				end
				MapKill(dupe)
				project.playsample_set(sampleplayer, oggnamed("sfx_0"), 1, 0)
			end,
			[engine.sdl.SDL_SCANCODE_LEFT]=function(self)
				local base = self.stage.base
				local w,h = base.w, base.h
				local dupe = MapMake(w,h)
				MapCopy(dupe,base)
				for x=0,(w-1) do
					for y=0,(h-1) do
						local c = project.get_color(dupe, x,y)
						project.set_color(base, (x+math.floor(w/3)-1)%w,y, c)
					end
				end
				MapKill(dupe)
				project.playsample_set(sampleplayer, oggnamed("sfx_2"), 1, 0)
 			end,
			[engine.sdl.SDL_SCANCODE_RIGHT]=function(self)
				local base = self.stage.base
				local w,h = base.w, base.h
				local dupe = MapMake(w,h)
				MapCopy(dupe,base)
				for x=0,(w-1) do
					for y=0,(h-1) do
						local c = project.get_color(dupe, x,y)
						project.set_color(base, x,(y+math.floor(w/3)-1)%h, c)
					end
				end
				MapKill(dupe)
				project.playsample_set(sampleplayer, oggnamed("sfx_2"), 1, 0)
			end,

--function keys
			[engine.sdl.SDL_SCANCODE_RETURN]=function(self)
				--screenshot?
				project.save_image(self.stage.base, "screenshot.png")
				project.playsample_set(sampleplayer, oggnamed("sfx_1"), 1, 0)
			end,
			[engine.sdl.SDL_SCANCODE_1]=function(self)
				project.set_brush_type(1)
				project.playsample_set(sampleplayer, oggnamed("brush_1"), 1, 0)
			end,
			[engine.sdl.SDL_SCANCODE_2]=function(self)
				project.set_brush_type(2)
				project.playsample_set(sampleplayer, oggnamed("brush_2"), 1, 0)
			end,
			[engine.sdl.SDL_SCANCODE_3]=function(self)
				project.set_brush_type(3)
				project.playsample_set(sampleplayer, oggnamed("brush_3"), 1, 0)
			end,
			[engine.sdl.SDL_SCANCODE_4]=function(self)
				project.set_brush_type(4)
				project.playsample_set(sampleplayer, oggnamed("brush_4"), 1, 0)
			end,
			[engine.sdl.SDL_SCANCODE_5]=function(self)
				project.set_brush_type(5)
				project.playsample_set(sampleplayer, oggnamed("brush_5"), 1, 0)
			end,
			[engine.sdl.SDL_SCANCODE_6]=function(self)
				project.set_brush_type(6)
				project.playsample_set(sampleplayer, oggnamed("brush_6"), 1, 0)
			end,
			[engine.sdl.SDL_SCANCODE_7]=function(self)
				project.set_brush_type(7)
				project.playsample_set(sampleplayer, oggnamed("brush_7"), 1, 0)
			end,
			[engine.sdl.SDL_SCANCODE_8]=function(self)
				project.set_brush_type(8)
				project.playsample_set(sampleplayer, oggnamed("brush_8"), 1, 0)
			end,
			[engine.sdl.SDL_SCANCODE_9]=function(self)
				project.set_brush_type(9)
				project.playsample_set(sampleplayer, oggnamed("brush_9"), 1, 0)
			end,
			[engine.sdl.SDL_SCANCODE_0]=function(self)
				project.set_brush_type(0)
				project.playsample_set(sampleplayer, oggnamed("numkey_0"), 1, 0)
			end,
			[engine.sdl.SDL_SCANCODE_F1]=function(self)
				project.set_brush_size(1)
				project.playsample_set(sampleplayer, oggnamed("numkey_1"), 1, 0)
			end,
			[engine.sdl.SDL_SCANCODE_F2]=function(self)
				project.set_brush_size(2)
				project.playsample_set(sampleplayer, oggnamed("numkey_2"), 1, 0)
			end,
			[engine.sdl.SDL_SCANCODE_F3]=function(self)
				project.set_brush_size(4)
				project.playsample_set(sampleplayer, oggnamed("numkey_3"), 1, 0)
			end,
			[engine.sdl.SDL_SCANCODE_F4]=function(self)
				project.set_brush_size(8)
				project.playsample_set(sampleplayer, oggnamed("numkey_4"), 1, 0)
			end,
			[engine.sdl.SDL_SCANCODE_F5]=function(self)
				project.set_brush_size(16)
				project.playsample_set(sampleplayer, oggnamed("numkey_5"), 1, 0)
			end,
			[engine.sdl.SDL_SCANCODE_F6]=function(self)
				project.set_brush_size(24)
				project.playsample_set(sampleplayer, oggnamed("numkey_6"), 1, 0)
			end,
			[engine.sdl.SDL_SCANCODE_F7]=function(self)
				project.set_brush_size(32)
				project.playsample_set(sampleplayer, oggnamed("numkey_7"), 1, 0)
			end,
			[engine.sdl.SDL_SCANCODE_F8]=function(self)
				project.set_brush_size(48)
				project.playsample_set(sampleplayer, oggnamed("numkey_8"), 1, 0)
			end,
			[engine.sdl.SDL_SCANCODE_F9]=function(self)
				project.set_brush_size(56)
				project.playsample_set(sampleplayer, oggnamed("numkey_9"), 1, 0)
			end,
			[engine.sdl.SDL_SCANCODE_F10]=function(self)
				project.set_brush_size(64)
				project.playsample_set(sampleplayer, oggnamed("numkey_10"), 1, 0)
			end,
			[engine.sdl.SDL_SCANCODE_F11]=function(self)
				project.set_brush_size(96)
				project.playsample_set(sampleplayer, oggnamed("numkey_11"), 1, 0)
			end,
			[engine.sdl.SDL_SCANCODE_F12]=function(self)
				project.set_brush_size(128)
				project.playsample_set(sampleplayer, oggnamed("numkey_12"), 1, 0)
			end
		},
	w=2,h=2})
	self:super(spec)
	self.color = engine.color_make(0xFF, 0xFF, 0x7F)
	self.altcolor = engine.color_make(0xFF, 0x7F, 0xFF)
end

function Player:onTick()
	if not self.blip then
		engine.draw_rect(self.x-self.w, self.y-self.h, self.w, self.h,
			self.blip and self.altcolor or self.color, self.stage.draw)
	end
end

class.Snapshot(Ent)

function Snapshot:_init(spec)
	pull(self, {
		down = {
			[engine.sdl.SDL_SCANCODE_DELETE]=self.reset,
			[engine.sdl.SDL_SCANCODE_BACKSPACE]=self.reset,
			[engine.sdl.SDL_SCANCODE_EQUALS]=self.snap
		}
	})
	self:super(spec)
	self.reserve = MapMake(self.onto.w,self.onto.h)
	self:snap()
end

function Snapshot:reset()
	engine.blit_whole(self.onto,self.reserve)
	self.last = engine.sdl.SDL_GetTicks()
	project.playsample_set(sampleplayer, oggnamed("sfx_6"), 1, 0)
end

function Snapshot:snap()
	engine.blit_whole(self.reserve,self.onto)
	self.last = engine.sdl.SDL_GetTicks()
	project.playsample_set(sampleplayer, oggnamed("sfx_7"), 1, 0)
end

function Snapshot:onTick()
	local now = engine.sdl.SDL_GetTicks()
	if now-self.last > 10*1000 then
		self:snap()
	end
end
